/*********************************************************************************
                                   SysTrayMenu.h
                                   -------------
    author               : Tamas Bara
    copyright            : (C) 2002-2004 by SnoozeSoft
    email                : snoozesoft@compuserve.de
 *********************************************************************************/

/*********************************************************************************
 *                                                                               *
 *   This library is free software; you can redistribute it and/or               *
 *   modify it under the terms of the GNU Lesser General Public                  *
 *   License as published by the Free Software Foundation; either                *
 *   version 2.1 of the License, or (at your option) any later version.          *
 *                                                                               *
 *   This library is distributed in the hope that it will be useful,             *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           *
 *   Lesser General Public License for more details.                             *
 *                                                                               *
 *   You should have received a copy of the GNU Lesser General Public            *
 *   License along with this library; if not, write to the Free Software         *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   *
 *                                                                               *
 *********************************************************************************/

#pragma once

#include "stdafx.h"

class SysTrayMenu
{
    public :

        SysTrayMenu( UINT id, jobject jObject, HICON hIcon, LPCWSTR toolTip );
        ~SysTrayMenu();

        friend class SysTrayManager;

    private :

        void enableItem( int id, bool enable );
        void checkItem( int id, bool check );
        void toggleCheckForItem( int id );
        void setItemLabel( int id, LPCWSTR label );
        void addItem( int id, LPCWSTR label, bool checkable, bool checked, bool enabled );
        void removeItem( int id );
        void removeAll();

    private :

        jobject             m_jobject;
        NOTIFYICONDATA      m_niData;
        UINT                m_id;
        HMENU               m_hMenu;
        bool                m_isIconVisible;
        list< int >         m_checkableItems;
};
